//Integration_ADXL345_WiFi
//TCP_Server
import processing.net.*;
int port = 13000;
Server myServer;
Client thisClient;

int gM=0;

import processing.serial.*;
Serial myPort;        // The serial port
float My=0;
float Mz=0;
float Mx=0;
float Py=0;
float Pz=0;
float Px=0;

import controlP5.*;
ControlP5 cp5;
DropdownList d1;
int mode;
float scale;

int gSW2=1;

MyJet MyJet;//使用クラスの定義
Yacht Yacht;
Train Train;
Engin Engin;
BirdBox BirdBox;
GuardRail GuardRail;
SolarUnits SolarUnits;
TrussStructure TrussStructure;

void setup ()
{
   size(1000, 800, P3D);
   println(Serial.list());
   myPort = new Serial(this, Serial.list()[1], 38400);
   myPort.bufferUntil('\n');   

   MyJet=new MyJet();//MyJetクラスのオブジェクトを生成
   Yacht=new Yacht();
   Train=new Train();
   Engin=new Engin();
   BirdBox=new BirdBox();
   GuardRail=new GuardRail();
   SolarUnits=new SolarUnits();
   TrussStructure=new TrussStructure();
   noStroke();
   
   cp5 = new ControlP5(this);
  
   cp5.addSlider("scale")
     .setPosition(200,0)
     .setSize(200,20)
     .setRange(0.1,2)
     .setColorLabel(color(0))
     .setValue(1.0);
     
    d1 = cp5.addDropdownList("List-d1")
          .setPosition(0, 0)
          .setSize(100,180)
          .setItemHeight(20)
          .setBarHeight(20)
          .addItem("My-Jet", 0)
          .addItem("Yacht", 1)
          .addItem("Train", 2)
          .addItem("Engin", 3)
          .addItem("Bird-Box", 4)
          .addItem("Guard-Rail", 5)
          .addItem("Solar-Units", 6)
          .addItem("Truss-Structure", 7);   
          
  myServer = new Server(this, port);
}
 

void draw ()
{
  if(abs(Mx)>abs(My))
  {
    if(abs(Mx)<0.3)
    {gM=0;}
    else
    {
      if(abs(Mx)<0.5)
      {gM=3;}
       else{gM=1;}
    }
  }
  else
  {
     if(abs(My)<0.3)
     {gM=0;}
     else
     {
        if(abs(My)<0.5)
        {gM=4;}
        else{gM=2;}
     }
  }
  //thisClient = myServer.available();
  thisClient = myServer.available();
  if (thisClient != null)
  {
    if (thisClient.available() > 0)
    {
      //println(thisClient.ip() + " : " + thisClient.readString());
      println(thisClient.readString());
      int MX=(int)(100*Mx);
      int MY=(int)(100*My);
      thisClient.write("BT"+gM+"#"+MX+"#"+MY+"#\r\n");
    }
  }
  
   pushMatrix();
   background(0, 256, 256);
   lights();
   
   translate(width / 2, height / 2);
   //rotateY(map(mouseX, 0, width, -PI/1, PI/1));
   //rotateX(map(mouseY, 0, height, PI/1, -PI/1));
   translate(Px,Py,Pz);
   rotateX(Mx);
   rotateY(Mz);
   rotateZ(My);
   scale = cp5.getController("scale").getValue();
   mode=(int)cp5.getController("List-d1").getValue();
   
   
   
   scale(scale,scale,scale);
   switch(mode) 
    {
      case(0):MyJet.MyJet();break;
      case(1):Yacht.Yacht();break;
      case(2):Train.Train();;break;
      case(3):Engin.Engin();break;
      case(4):BirdBox.BirdBox();break;
      case(5):GuardRail.GuardRail();break;
      case(6):SolarUnits.SolarUnits();break;
      case(7):TrussStructure.TrussStructure();break;
    }
   popMatrix();
   
   if (myPort.available() <= 0){myPort.write("B");}
}
 
void controlEvent(ControlEvent theEvent)
{
  if (theEvent.isController())
  {
    println(theEvent.getController()+"\t"+mode+"\t"+ scale);
  }
}

void serialEvent(Serial myPort)
{
  float  r=0.5;
  String myString = myPort.readStringUntil('\n');
  myString = trim(myString);
  float sensors[] = float(split(myString, ','));
  for (int sensorNum = 0; sensorNum < sensors.length; sensorNum++) 
  {
     print(sensors[sensorNum] + "\t");
  }
  println();
  
  if(sensors[3]==1)
  {
    Mx=Mx*(1-r)+sensors[0]*r/100;//重力方向
    My=My*(1-r)+sensors[1]*r/100;//重力方向
    if(sensors[0]*sensors[0]+sensors[1]*sensors[1]<40*40)
    {
      Mz=Mz*(1-r)+(sensors[2]+100)*r/100;//磁力方向
    }

  }
  else
  {
    Px=Px*(1-r)+400*(sensors[0]/100)*r;//重力方向
    Py=Py*(1-r)+400*(sensors[1]/100)*r;//重力方向
    if(sensors[0]*sensors[0]+sensors[1]*sensors[1]<40*40)
    {
      Pz=Pz*(1-r)+400*((sensors[2]+100)/100)*r;//磁力方向
    }
  }   
  myPort.write("A");
  if(sensors[4]==0)
  {
    if(gSW2==1)
    {
      mode++;
      if(mode>7){mode=0;}
      cp5.getController("List-d1").setValue(mode);
      //d1.setValue(mode);
    }
    gSW2=0;
  }
  else
  {
    gSW2=1;
  }
  
  if(sensors[5]==0)
  {
    cp5.getController("scale").setValue(scale+0.01);
    delay(10);
  }
  
  if(sensors[6]==0)
  {
    cp5.getController("scale").setValue(scale-0.01);
    delay(10);
  }
 
}

 

 
